﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Xml.Linq;
using System.Windows.Media;

using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using System.Timers;
using Styx.Common;

namespace HotkeyPresser
{
    public class HotkeyPresser : HBPlugin
    {
        public override string Name { get { return "HotkeyPresser"; } }
        public override string Author { get { return "Liferose"; } }
        public override Version Version { get { return new Version(1, 0, 0, 1); } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        private static System.Timers.Timer PressingTimer;
        private int Milliseconds = PresserSettings.Instance.Minutes;

        public override void OnButtonPress()
        {
            var config = new HotkeyPresserUI();
            config.ShowDialog();
        }
   
        public void Restart()
        {
            PressingTimer.Stop();
            PressingTimer.Start();
        }

        public override void OnEnable()
        {
            PressingTimer = new System.Timers.Timer();
            PressingTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
            PressingTimer.Interval = Milliseconds * 60000;
            PressingTimer.Enabled = true;
        }

        public override void OnDisable()
        {
            PressingTimer.Elapsed -= new ElapsedEventHandler(OnTimedEvent);
        }

        private static void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            Logging.Write(Colors.Lime, "Hotkey: Pressing key.");

            PressingTimer.Stop();
            HotkeyPresserUI UI = new HotkeyPresserUI();
            UI.Presser();
            PressingTimer.Start();
        }

        public override void Pulse()
        {
        }
    }

}
